<?php
//some anti hacking stuff
if ($_SERVER['SERVER_NAME'] !== $_SERVER['HTTP_HOST'])
{
  header('Location: http://' . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . '?' . $_SERVER['QUERY_STRING']);
  exit;
}

// The actual function
// Show events between $dateFrom and $dateTo.
function ssi_ListEvents($max_events = 7, $output_method = 'echo', $dateFrom = '01-01-01', $dateTo = '01-01-01', $boards = null)
{
	global $db_prefix, $user_info, $scripturl, $modSettings, $txt, $sc, $ID_MEMBER, $smcFunc;
        if ($boards === null)
        {
                    $boards = $user_info['query_see_board'];
	// Find all events which are happening in the near future that the member can see.
	$request = $smcFunc['db_query']('', '
		SELECT
			cal.ID_EVENT, cal.start_date, cal.end_date, cal.title, cal.ID_MEMBER, cal.ID_TOPIC,
			cal.ID_BOARD, t.ID_FIRST_MSG
		FROM {db_prefix}calendar AS cal
			LEFT JOIN {db_prefix}boards AS b ON (b.ID_BOARD = cal.ID_BOARD)
			LEFT JOIN {db_prefix}topics AS t ON (t.ID_TOPIC = cal.ID_TOPIC)
		WHERE cal.start_date <= {date:date_to}
			AND cal.start_date >= {date:date_from}
			AND (cal.ID_BOARD = 0 OR {string:boards})
		ORDER BY cal.start_date ASC
		LIMIT {int:max_events}',
                array(
                       'max_events' => $max_events,
                       'date_from' => $dateFrom,
                       'date_to' => $dateTo,
                       'boards' => $boards
                ));
        }
        else
        {
	$request = $smcFunc['db_query']('', '
		SELECT
			cal.ID_EVENT, cal.start_date, cal.end_date, cal.title, cal.ID_MEMBER, cal.ID_TOPIC,
			cal.ID_BOARD, t.ID_FIRST_MSG
		FROM {db_prefix}calendar AS cal
			LEFT JOIN {db_prefix}boards AS b ON (b.ID_BOARD = cal.ID_BOARD)
			LEFT JOIN {db_prefix}topics AS t ON (t.ID_TOPIC = cal.ID_TOPIC)
		WHERE cal.start_date <= {date:date_to}
			AND cal.start_date >= {date:date_from}
			AND (cal.ID_BOARD IN ({array_int:boards}))
		ORDER BY cal.start_date ASC
		LIMIT {int:max_events}',
                array(
                       'max_events' => $max_events,
                       'date_from' => $dateFrom,
                       'date_to' => $dateTo,
                       'boards' => $boards
                ));
        }
	$return = array();
	$duplicates = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		// Censor the title.
		censorText($row['title']);

			$date = $row['start_date'];

		$return[$date][] = array(
			'id' => $row['ID_EVENT'],
			'title' => $row['title'],
			'can_edit' => allowedTo('calendar_edit_any') || ($row['ID_MEMBER'] == $ID_MEMBER && allowedTo('calendar_edit_own')),
			'modify_href' => $scripturl . '?action=' . ($row['ID_BOARD'] == 0 ? 'calendar;sa=post;' : 'post;msg=' . $row['ID_FIRST_MSG'] . ';topic=' . $row['ID_TOPIC'] . '.0;calendar;') . 'eventid=' . $row['ID_EVENT'] . ';sesc=' . $sc,
			'href' => $row['ID_BOARD'] == 0 ? '' : $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => $row['ID_BOARD'] == 0 ? $row['title'] : '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['title'] . '</a>',
			'start_date' => $row['start_date'],
			'end_date' => $row['end_date'],
			'is_last' => false
		);

		// Let's not show this one again, huh?
		$duplicates[$row['title'] . $row['ID_TOPIC']] = true;
	}
	$smcFunc['db_free_result']($request);

	foreach ($return as $mday => $array)
		$return[$mday][count($array) - 1]['is_last'] = true;

	if ($output_method != 'echo' || empty($return))
		return $return;

	// Well the output method is echo.
	$tempyear = 0001;
        $tempmonth = 'bob';
	foreach ($return as $mday => $array)
		foreach ($array as $event)
		{
			if (strftime("%Y",strtotime($event['start_date'])) != $tempyear)
			{
                          $tempyear = strftime("%Y",strtotime($event['start_date']));
                          echo '<h3>' . $tempyear . '</h3>';
                        }
                        if (strftime("%B",strtotime($event['start_date'])) != $tempmonth)
			{
                          $tempmonth = strftime("%B",strtotime($event['start_date']));
                          echo '<h3>' . $tempmonth . '</h3>';
                        }
                        if ($event['can_edit'])
				echo '
				<a href="' . $event['modify_href'] . '" style="color: #FF0000;">*</a> ';

			echo '
				' . date("jS",strtotime($event['start_date']));
                        if ($event['start_date'] != $event['end_date'])
                          echo '-' . date("jS",strtotime($event['end_date']));
                        echo ' ' . ($user_info['is_guest'] ? $event['title'] : $event['link']) . '<br/>';
		}
}
?>